import { compile, VNScene, VNSceneBasisPart } from "./vnscene.ts";
import {
  sndVnBat,
  sndVnBreath,
  sndVnDance,
  sndVnDoorbell,
  sndVnGhost,
  sndVnPage,
  sndVnPhone,
} from "./sounds.ts";

const squeak: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnBat,
};

export const sceneBat: VNScene = compile([
  squeak,
  "I didn't.",
  "I tried to, but --",
  squeak,
  "Well, you know what they say.",
  "But I didn't disappear, right?",
  "I'm still here.",
  squeak,
  "That's actually _why_ I stopped.",
  "Talking is --",
  squeak,
  "Well. You know.",
  squeak,
]);

const doorbell: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnDoorbell,
};

export const sceneStealth: VNScene = compile([
  doorbell,
  "Yeah, you can let yourself in.",
  doorbell,
  "I'll have it moved.",
  "Just -- don't call Liz, OK?",
  doorbell,
  "Believe me, I'm good for the money.",
  "I'm doing... a lot better than it looks like.",
  doorbell,
  "The fangs? They're not real.",
  "I'm just like you.",
  doorbell,
]);

const phoneBeep: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnPhone,
};

export const sceneCharm: VNScene = compile([
  phoneBeep,
  "How do I sound?",
  phoneBeep,
  "*chuckle*",
  "Sorry. I didn't plan ahead of time.",
  "We're not on the air?",
  phoneBeep,
  "Well, I want a song.",
  "Can you put me through?",
  phoneBeep,
  "I really want it.",
  "It's for my boyfriend. My old boyfriend, sorry.",
  phoneBeep,
  "*chuckle*",
  "Yeah. I guess I do.",
  "Is that bad?",
  phoneBeep,
]);

const sleepyBreath: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnBreath,
};

export const sceneStare: VNScene = compile([
  sleepyBreath,
  "Don't wake up.",
  "You're home.",
  "A lot of things have been happening pretty fast.",
  sleepyBreath,
  "You have a lot of friends. You stick together.",
  "You didn't have that when you were younger.",
  sleepyBreath,
  "It's not bad when things change.",
  "And all that other stuff. It was a long time ago.",
  "I couldn't really stop myself...",
  sleepyBreath,
]);

const party: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnDance,
};

export const sceneParty: VNScene = compile([
  party, // party noises
  "IT'S LOUD?",
  party, // party noises
  "I KNOW.",
  party, // party noises
  "LISTEN, I --",
  party, // party noises
  "IF I DON'T SEE YOU AGAIN, I --",
  party, // party noises
]);

const ghost: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnGhost,
};

export const sceneLore: VNScene = compile([
  ghost,
  "Oh yeah, I canceled those.",
  ghost,
  "I'll tell you the answers later.",
  "I guess if I said it now that would be --",
  "It'd be like cheating, right?",
  ghost,
  "Don't say that! I visit you, don't I?",
  ghost,
  "Yeah. They remember.",
  ghost,
]);

const page: VNSceneBasisPart = {
  type: "message",
  text: "...",
  sfx: sndVnPage,
};

export const sceneTrueEnding: VNScene = compile([
  page,
  "(This is a taxonomy. It's what nerds write instead of poetry.)",
  page,
  "INSECTIVORE. INSECTIPHAGE. INSECT-EATER. INSECT-EATING INSECT BAT.",
  "CONSUMER OF BUGS.",
  "We eat -- flies? They eat beetles.",
  "We eat -- various bugs. Yes. And we hang in caves --",
  "We deposit the shells in a heap. An absolutely massive heap --",
  page,
  "FRUCTIVORE. FRUITIPHAGE. FRUIT-EATING FRUIT BAT.",
  "We eat -- grapes, melons, that kind of thing.",
  "We unearth the heap.",
  "We lay the shells in trenches in the furrows of a vineyard.",
  page,
  "There are two clades and in addition to that is a secret clade.",
  page,
  "(The pages are stuck together.)",
  page,
  "HEMOPHAGE. HEMOVORE. HEMATOPHAGE. BLOOD EATER.",
  "It is not yet time to announce the sentence of fate.",
  "We -- take the wine that grows from the branches.",
  "That's a simplification.",
  "This is the night deeper than any night that cannot be spoken of.",
  page,
  "OK -- now roll it.",
]);
